> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Write off an invoice asynchronously

POST https://rest.test.zuora.com/v1/invoices/{invoiceKey}/write-off-async
Content-Type: application/json

Asynchronously writes off a posted invoice.\n\nBy writing\ \ off an invoice, a credit memo is created and applied to the invoice. If the\ \ invoice contains more than 2,000 items, this operation is performed asynchronously.\ \ Use the [Retrieve invoice write-off async job](https://developer.zuora.com/v1-api-reference/api/invoices/retrieveinvoicewriteoffasyncjob) \ operation to track the status of the async job.\n\n**Note:** This operation is only available if you have \<a href="[https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/get-started-with-invoice-settlement/invoice-settlement-overview](https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/get-started-with-invoice-settlement/invoice-settlement-overview)" target=“\_blank”>Invoice Settlement\</a>\ \ enabled. The Invoice Settlement feature is generally available as of Zuora Billing\ \ Release 296 (March 2021). This feature includes Unapplied Payments, Credit and\ \ Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement,\ \ see \<a href="[https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/invoice-settlement-migration-checklist-and-guide](https://docs.zuora.com/en/zuora-billing/bill-your-customer/adjust-invoice-amounts/invoice-settlement/invoice-settlement-migration-checklist-and-guide)" target=“\_blank”>Invoice Settlement Enablement and Checklist Guide\</a>\ \ for more information.\n

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/invoices/write-off-invoice-async

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `invoiceKey` (string, required) — The ID or number of the invoice. For example, 2c92c8955bd63cc1015bd7c151af02ab or INV-0000001.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Authorization` (string, optional) — The value is in the `Bearer {token}` format where \{token} is a valid OAuth token generated by calling [Create an OAuth token](https://developer.zuora.com/api-references/api/operation/createToken).
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

### Body (application/json)

This endpoint expects a WriteOffInvoiceRequest.

- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the credit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Origin__NS` (string, optional) — Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the credit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Transaction__NS` (string, optional) — Related transaction in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `amount` (double, optional) — The write off amount of the invoice. **Note**: This field is available only if you have enabled the enhanced write-off permission for your tenant. Contact Zuora Global Support to enable this permission.
- `comment` (string, optional) — Comments about the write-off. The comment is used as the comment of the credit memo generated by writing off the specified invoice.
- `items` (list of CreditMemoItemFromWriteOffInvoice, optional) — Container for items. This field is optional. **Note:** * If specified, you must specify ALL the items of the invoice. The entire balance of the invoice will be written off, you cannot just write off some items of the invoice. * This field is available only if you have enabled the enhanced write-off permission for your tenant. Contact Zuora Global Support to enable this permission.
- `memoDate` (date, optional) — The date when the credit memo was created, in `yyyy-mm-dd` format. The memo date must be later than or equal to the invoice date. The default value is the date when you write off the invoice.
- `nonRevenueWriteOffAccountingCode` (string, optional) — Specify the accounting code for the non revenue write off. Available only if `revenueImpacting` = `no`. **Note**: This field is available only if you have enabled the enhanced write-off permission for your tenant. Contact Zuora Global Support to enable this permission.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code `Write-off`.
- `revenueImpacting` (enum, optional, default: Yes) — Indicates whether this write off operation impacts the revenue. If `revenueImpacting` = `Yes`, the deferred revenue accounting code will be automatically selected from the associated invoice The **Exclude Billing Item From Revenue** field will be automatically set to **Yes** by default for such non-revenue impacting write off credit memos, and this setting cannot be changed. This enhancement helps ensure that only revenue-impacting items are synchronized with Zuora Revenue, reducing unnecessary data processing. If `revenueImpacting` = `No`, users can select an accounting code such as bad-debt expense accounting code for the write off operation. **Note**: This field is available only if you have enabled the enhanced write-off permission for your tenant. Contact Zuora Global Support to enable this permission.
  - Allowed values: `Yes`, `No`

## Response

### 200

OK

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of WriteOffInvoiceAsyncJobResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.
- `id` (string, optional) — The ID of the operation job.
- `status` (enum, optional) — Job status of the Invoice Settlement async job.
  - Allowed values: `Pending`, `Processing`, `Processed`, `Error`
- `operationType` (enum, optional) — Operation type of the Invoice Settlement async job.
  - Allowed values: `AsyncCreditMemoApply`, `AsyncCreditMemoUnapply`
- `referenceId` (string, optional) — The ID of the business object which is being operated.
- `referenceType` (enum, optional) — Reference type of the Invoice Settlement async job.
  - Allowed values: `CreditMemo`
- `error` (string, optional, nullable) — The error message if the operation fails.
- `creditMemo` (WriteOffInvoiceResponseCreditMemo, optional) — Container for the credit memo that is automatically generated when writing off invoices.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Invalid input

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### CreditMemoItemFromWriteOffInvoice

Container for custom fields of a Credit Memo Item object.

- `comment` (string, optional) — Comments about the credit memo item.
- `financeInformation` (CreditMemoItemFromWriteOffInvoiceFinanceInformation, optional) — Container for the finance information related to the credit memo item.
- `invoiceItemId` (string, optional) — The ID of the invoice item.
- `serviceEndDate` (date, optional) — The service end date of the credit memo item.
- `amountWithoutTax` (double, optional) — The write off amount of the invoice item excluding tax.
- `serviceStartDate` (date, optional) — The service start date of the credit memo item.
- `skuName` (string, optional) — The name of the charge associated with the invoice.
- `unitOfMeasure` (string, optional) — The definable unit that you measure when determining charges.
- `taxationItems` (list of CreditMemoItemFromWriteOffInvoiceTaxationItemsItems, optional) — Container for the taxation items of the credit memo item. **Note**: * This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `239.0` or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version).

### WriteOffInvoiceAsyncJobResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### WriteOffInvoiceResponseCreditMemo

Container for the credit memo that is automatically generated when writing off invoices.

- `id` (string, optional) — The ID of the credit memo that is created when the invoice is written off.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CreditMemoItemFromWriteOffInvoiceFinanceInformation

Container for the finance information related to the credit memo item.

- `deferredRevenueAccountingCode` (string, optional) — The accounting code for the deferred revenue, such as Monthly Recurring Liability.
- `onAccountAccountingCode` (string, optional) — The accounting code that maps to an on account in your accounting system.
- `recognizedRevenueAccountingCode` (string, optional) — The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges.
- `revenueRecognitionRuleName` (string, optional) — The name of the revenue recognition rule governing the revenue schedule.

### CreditMemoItemFromWriteOffInvoiceTaxationItemsItems

- `amount` (double, optional) — The credit memo taxation amount.
- `taxationItemId` (string, optional) — The Id of the debit memo item.

## Examples

**Request**

```json
{
  "comment": "Customer bankruptcy - writing off outstanding balance",
  "items": [
    {
      "comment": "Item-level comment",
      "invoiceItemId": "8ad097b490a1ec740190a5aaece25734",
      "serviceEndDate": "2024-01-31",
      "serviceStartDate": "2024-01-01"
    }
  ],
  "memoDate": "2024-08-19",
  "reasonCode": "Write-off"
}
```

**Response**

```json
{
  "success": true,
  "id": "40288ae9600808280160081dc9c13f15",
  "status": "Pending",
  "operationType": "AsyncCreditMemoApply",
  "referenceId": "4028905f5a890526015a8d73f73d0015",
  "referenceType": "CreditMemo",
  "error": null,
  "creditMemo": {
    "id": "402890555a40ca7f015a5b099b0e307a"
  }
}
```

**SDK Code**

```python Invoices_writeOffInvoiceAsync_example
import requests

url = "https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async"

payload = {
    "comment": "Customer bankruptcy - writing off outstanding balance",
    "items": [
        {
            "comment": "Item-level comment",
            "invoiceItemId": "8ad097b490a1ec740190a5aaece25734",
            "serviceEndDate": "2024-01-31",
            "serviceStartDate": "2024-01-01"
        }
    ],
    "memoDate": "2024-08-19",
    "reasonCode": "Write-off"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Invoices_writeOffInvoiceAsync_example
const url = 'https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"comment":"Customer bankruptcy - writing off outstanding balance","items":[{"comment":"Item-level comment","invoiceItemId":"8ad097b490a1ec740190a5aaece25734","serviceEndDate":"2024-01-31","serviceStartDate":"2024-01-01"}],"memoDate":"2024-08-19","reasonCode":"Write-off"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Invoices_writeOffInvoiceAsync_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async"

	payload := strings.NewReader("{\n  \"comment\": \"Customer bankruptcy - writing off outstanding balance\",\n  \"items\": [\n    {\n      \"comment\": \"Item-level comment\",\n      \"invoiceItemId\": \"8ad097b490a1ec740190a5aaece25734\",\n      \"serviceEndDate\": \"2024-01-31\",\n      \"serviceStartDate\": \"2024-01-01\"\n    }\n  ],\n  \"memoDate\": \"2024-08-19\",\n  \"reasonCode\": \"Write-off\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Invoices_writeOffInvoiceAsync_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"comment\": \"Customer bankruptcy - writing off outstanding balance\",\n  \"items\": [\n    {\n      \"comment\": \"Item-level comment\",\n      \"invoiceItemId\": \"8ad097b490a1ec740190a5aaece25734\",\n      \"serviceEndDate\": \"2024-01-31\",\n      \"serviceStartDate\": \"2024-01-01\"\n    }\n  ],\n  \"memoDate\": \"2024-08-19\",\n  \"reasonCode\": \"Write-off\"\n}"

response = http.request(request)
puts response.read_body
```

```java Invoices_writeOffInvoiceAsync_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"comment\": \"Customer bankruptcy - writing off outstanding balance\",\n  \"items\": [\n    {\n      \"comment\": \"Item-level comment\",\n      \"invoiceItemId\": \"8ad097b490a1ec740190a5aaece25734\",\n      \"serviceEndDate\": \"2024-01-31\",\n      \"serviceStartDate\": \"2024-01-01\"\n    }\n  ],\n  \"memoDate\": \"2024-08-19\",\n  \"reasonCode\": \"Write-off\"\n}")
  .asString();
```

```php Invoices_writeOffInvoiceAsync_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async', [
  'body' => '{
  "comment": "Customer bankruptcy - writing off outstanding balance",
  "items": [
    {
      "comment": "Item-level comment",
      "invoiceItemId": "8ad097b490a1ec740190a5aaece25734",
      "serviceEndDate": "2024-01-31",
      "serviceStartDate": "2024-01-01"
    }
  ],
  "memoDate": "2024-08-19",
  "reasonCode": "Write-off"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Invoices_writeOffInvoiceAsync_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"comment\": \"Customer bankruptcy - writing off outstanding balance\",\n  \"items\": [\n    {\n      \"comment\": \"Item-level comment\",\n      \"invoiceItemId\": \"8ad097b490a1ec740190a5aaece25734\",\n      \"serviceEndDate\": \"2024-01-31\",\n      \"serviceStartDate\": \"2024-01-01\"\n    }\n  ],\n  \"memoDate\": \"2024-08-19\",\n  \"reasonCode\": \"Write-off\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Invoices_writeOffInvoiceAsync_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "comment": "Customer bankruptcy - writing off outstanding balance",
  "items": [
    [
      "comment": "Item-level comment",
      "invoiceItemId": "8ad097b490a1ec740190a5aaece25734",
      "serviceEndDate": "2024-01-31",
      "serviceStartDate": "2024-01-01"
    ]
  ],
  "memoDate": "2024-08-19",
  "reasonCode": "Write-off"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/invoices/invoiceKey/write-off-async")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```